diff -Naur --exclude=CVS --exclude=configs linux/init/main.c linux-openmosix/init/main.c
--- linux/init/main.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/init/main.c	2004-02-05 10:51:28.000000000 +0100
@@ -74,6 +74,10 @@
 #include <asm/smp.h>
 #endif
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 /*
  * Versions of gcc older than that listed below may actually compile
  * and link okay, but the end product can have subtle run time bugs.
@@ -567,6 +571,9 @@
 	 * initmem segments and start the user-mode stuff..
 	 */
 	free_initmem();
+#ifdef CONFIG_MOSIX
+	init_mosix();
+#endif /* CONFIG_MOSIX */
 	unlock_kernel();
 	
 	/*
diff -Naur --exclude=CVS --exclude=configs linux/ipc/shm.c linux-openmosix/ipc/shm.c
--- linux/ipc/shm.c	2002-08-03 02:39:46.000000000 +0200
+++ linux-openmosix/ipc/shm.c	2004-02-05 10:51:29.000000000 +0100
@@ -12,7 +12,8 @@
  * Make shmmax, shmall, shmmni sysctl'able, Christoph Rohland <cr@sap.com>
  * Shared /dev/zero support, Kanoj Sarcar <kanoj@sgi.com>
  * Move the mm functionality over to mm/shmem.c, Christoph Rohland <cr@sap.com>
- *
+ * 
+ * Some changes by Moshe Bar to eliminate fh leaking problem in openMosix
  */
 
 #include <linux/config.h>
@@ -23,7 +24,7 @@
 #include <linux/mman.h>
 #include <linux/proc_fs.h>
 #include <asm/uaccess.h>
-
+#include <linux/hpc.h>
 #include "util.h"
 
 struct shmid_kernel /* private to the kernel */
@@ -495,6 +496,9 @@
 		 *	Instead we set a destroyed flag, and then blow
 		 *	the name away when the usage hits zero.
 		 */
+#ifdef CONFIG_MOSIX
+ 		/* mosix_rebuild_file_list();  fh leakage fixed - moshe */
+#endif
 		down(&shm_ids.sem);
 		shp = shm_lock(shmid);
 		err = -EINVAL;
@@ -627,6 +631,9 @@
 	shp->shm_nattch++;
 	shm_unlock(shmid);
 
+#ifdef CONFIG_MOSIX
+	user_addr = (void *) do_mmap_down (file, addr, size, prot, flags, 0);
+#else
 	down_write(&current->mm->mmap_sem);
 	if (addr && !(shmflg & SHM_REMAP)) {
 		user_addr = ERR_PTR(-EINVAL);
@@ -645,6 +652,7 @@
 
 invalid:
 	up_write(&current->mm->mmap_sem);
+#endif /* CONFIG_MOSIX */
 
 	down (&shm_ids.sem);
 	if(!(shp = shm_lock(shmid)))
@@ -675,6 +683,11 @@
 	struct vm_area_struct *shmd, *shmdnext;
 	int retval = -EINVAL;
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+		return(0);
+	mosix_rebuild_file_list();
+#endif /* CONFIG_MOSIX */
 	down_write(&mm->mmap_sem);
 	for (shmd = mm->mmap; shmd; shmd = shmdnext) {
 		shmdnext = shmd->vm_next;
diff -Naur --exclude=CVS --exclude=configs linux/kernel/acct.c linux-openmosix/kernel/acct.c
--- linux/kernel/acct.c	2002-08-03 02:39:46.000000000 +0200
+++ linux-openmosix/kernel/acct.c	2004-02-05 10:51:30.000000000 +0100
@@ -57,6 +57,9 @@
 
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
 /*
  * These constants control the amount of freespace that suspend and
  * resume the process accounting system, and the time delay between
@@ -203,6 +206,10 @@
 	}
 	unlock_kernel();
 	if (old_acct) {
+#ifdef CONFIG_MOSIX
+		if(current->mosix.dflags & DDEPUTY)
+			mosix_deputy_rusage(2);
+#endif /* CONFIG_MOSIX */
 		do_acct_process(0,old_acct);
 		filp_close(old_acct, NULL);
 	}
@@ -279,6 +286,10 @@
 	unsigned long vsize;
 	unsigned long flim;
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DREMOTE)
+		return;
+#endif /* CONFIG_MOSIX */
 	/*
 	 * First check to see if there is enough free_space to continue
 	 * the process accounting system.
@@ -324,6 +335,10 @@
 		}
 		up_read(&current->mm->mmap_sem);
 	}
+#ifdef CONFIG_MOSIX
+	else	/* were we a DEPUTY?  otherwise, "mosix.exit_mem" is 0 anyway */
+		vsize = current->mosix.exit_mem;
+#endif /* CONFIG_MOSIX */
 	vsize = vsize / 1024;
 	ac.ac_mem = encode_comp_t(vsize);
 	ac.ac_io = encode_comp_t(0 /* current->io_usage */);	/* %% */
diff -Naur --exclude=CVS --exclude=configs linux/kernel/capability.c linux-openmosix/kernel/capability.c
--- linux/kernel/capability.c	2000-06-24 06:06:37.000000000 +0200
+++ linux-openmosix/kernel/capability.c	2004-02-05 10:51:30.000000000 +0100
@@ -7,6 +7,9 @@
 
 #include <linux/mm.h>
 #include <asm/uaccess.h>
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
 
 kernel_cap_t cap_bset = CAP_INIT_EFF_SET;
 
@@ -85,7 +88,11 @@
 
      /* FIXME: do we need to have a write lock here..? */
      read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+     for_each_local_task(target) {
+#else
      for_each_task(target) {
+#endif /* CONFIG_MOSIX */
              if (target->pgrp != pgrp)
                      continue;
              target->cap_effective   = *effective;
@@ -106,7 +113,11 @@
      /* FIXME: do we need to have a write lock here..? */
      read_lock(&tasklist_lock);
      /* ALL means everyone other than self or 'init' */
+#ifdef CONFIG_MOSIX
+     for_each_local_task(target) {
+#else
      for_each_task(target) {
+#endif /* CONFIG_MOSIX */
              if (target == current || target->pid == 1)
                      continue;
              target->cap_effective   = *effective;
@@ -212,5 +223,8 @@
      }
 spin_out:
      spin_unlock(&task_capability_lock);
+#ifdef CONFIG_MOSIX
+     mosix_sync_caps(effective);
+#endif /* CONFIG_MOSIX */
      return error;
 }
diff -Naur --exclude=CVS --exclude=configs linux/kernel/exec_domain.c linux-openmosix/kernel/exec_domain.c
--- linux/kernel/exec_domain.c	2003-08-25 13:44:44.000000000 +0200
+++ linux-openmosix/kernel/exec_domain.c	2004-02-05 10:51:30.000000000 +0100
@@ -16,6 +16,10 @@
 #include <linux/sched.h>
 #include <linux/sysctl.h>
 #include <linux/types.h>
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#include <asm/namei.h>
+#endif /* CONFIG_MOSIX */
 
 
 static void default_handler(int, struct pt_regs *);
@@ -73,7 +77,11 @@
 		send_sig(SIGSEGV, current, 1);
 }
 
+#ifdef CONFIG_MOSIX
+struct exec_domain *
+#else
 static struct exec_domain *
+#endif /* CONFIG_MOSIX */
 lookup_exec_domain(u_long personality)
 {
 	struct exec_domain *	ep;
@@ -167,7 +175,11 @@
 		return 0;
 	}
 
+#ifdef CONFIG_MOSIX_DFSA
+	if (atomic_read(&current->fs->users) != 1) {
+#else
 	if (atomic_read(&current->fs->count) != 1) {
+#endif /* CONFIG_MOSIX_DFSA */
 		struct fs_struct *fsp, *ofsp;
 
 		fsp = copy_fs_struct(current->fs);
@@ -181,7 +193,11 @@
 		current->fs = fsp;
 		task_unlock(current);
 
+#ifdef CONFIG_MOSIX_DFSA
+		put_used_fs_struct(ofsp);
+#else
 		put_fs_struct(ofsp);
+#endif /* CONFIG_MOSIX_DFSA */
 	}
 
 	/*
@@ -189,6 +205,37 @@
 	 * current->fs.
 	 */
 
+#ifdef CONFIG_MOSIX
+	if((current->mosix.dflags & DDEPUTY) &&
+		personality != current->personality &&
+		mosix_deputy_personality(personality))
+	{
+		if(!current->mosix.inexec)
+			mosix_go_home(1);
+		if(current->mosix.dflags & DDEPUTY)
+		{
+			put_exec_domain(ep);
+			printk("%d(%s)-killed because it could not go back home"
+				"and\nits new personality (%ld) is not"
+				" supported where it ran (%d)\n", current->pid,
+				current->comm, personality,
+				current->mosix.whereami);
+			send_sig(SIGKILL, current, 1);
+			return(-EINVAL);
+		}
+	}
+	else if(current->mosix.dflags & DREMOTE)
+	{
+		unsigned long prev = current->personality;
+
+		current->personality = personality;
+		if(__emul_prefix())
+		{
+			current->personality = prev;
+			return(-EINVAL);
+		}
+	}
+#endif /* CONFIG_MOSIX */
 	current->personality = personality;
 	oep = current->exec_domain;
 	current->exec_domain = ep;
diff -Naur --exclude=CVS --exclude=configs linux/kernel/exit.c linux-openmosix/kernel/exit.c
--- linux/kernel/exit.c	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/kernel/exit.c	2004-02-05 10:51:30.000000000 +0100
@@ -16,6 +16,9 @@
 #ifdef CONFIG_BSD_PROCESS_ACCT
 #include <linux/acct.h>
 #endif
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
 
 #include <asm/uaccess.h>
 #include <asm/pgtable.h>
@@ -85,7 +88,11 @@
 
 	fallback = -1;
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
  		if (p->session <= 0)
  			continue;
 		if (p->pgrp == pgrp) {
@@ -112,9 +119,17 @@
 	struct task_struct *p;
 
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		if ((p == ignored_task) || (p->pgrp != pgrp) ||
+#ifdef CONFIG_MOSIX
+		    (LOGICAL_STATE(p) == TASK_ZOMBIE) ||
+#else
 		    (p->state == TASK_ZOMBIE) ||
+#endif /* CONFIG_MOSIX */
 		    (p->p_pptr->pid == 1))
 			continue;
 		if ((p->p_pptr->pgrp != pgrp) &&
@@ -138,10 +153,18 @@
 	struct task_struct * p;
 
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		if (p->pgrp != pgrp)
 			continue;
+#ifdef CONFIG_MOSIX
+		if (LOGICAL_STATE(p) != TASK_STOPPED)
+#else
 		if (p->state != TASK_STOPPED)
+#endif /* CONFIG_MOSIX */
 			continue;
 		retval = 1;
 		break;
@@ -177,7 +200,11 @@
 	read_unlock(&tasklist_lock);
 }
 
+#ifdef CONFIG_MOSIX_DFSA
+void close_files(struct files_struct * files)
+#else
 static inline void close_files(struct files_struct * files)
+#endif /* CONFIG_MOSIX_DFSA */
 {
 	int i, j;
 
@@ -212,6 +239,11 @@
 		if (files->max_fdset > __FD_SETSIZE) {
 			free_fdset(files->open_fds, files->max_fdset);
 			free_fdset(files->close_on_exec, files->max_fdset);
+#ifdef CONFIG_MOSIX_DFSA
+			free_fdset(files->closed, files->max_fdset);
+			free_fdset(files->opened, files->max_fdset);
+			free_fdset(files->modified, files->max_fdset);
+#endif /* CONFIG_MOSIX_DFSA */
 		}
 		kmem_cache_free(files_cachep, files);
 	}
@@ -225,6 +257,11 @@
 		task_lock(tsk);
 		tsk->files = NULL;
 		task_unlock(tsk);
+#ifdef CONFIG_MOSIX_DFSA
+		atomic_dec(&files->users);
+		if(atomic_read(&files->users) == 1)
+			files->count_dropped_to_one = 1;
+#endif /* CONFIG_MOSIX_DFSA */
 		put_files_struct(files);
 	}
 }
@@ -255,6 +292,17 @@
 	__put_fs_struct(fs);
 }
 
+#ifdef CONFIG_MOSIX_DFSA
+inline void
+put_used_fs_struct(struct fs_struct *fs)
+{
+	atomic_dec(&fs->users);
+	if(atomic_read(&fs->users) == 1)
+		fs->count_dropped_to_one = 1;
+	__put_fs_struct(fs);
+}
+#endif /* CONFIG_MOSIX_DFSA */
+
 static inline void __exit_fs(struct task_struct *tsk)
 {
 	struct fs_struct * fs = tsk->fs;
@@ -263,7 +311,11 @@
 		task_lock(tsk);
 		tsk->fs = NULL;
 		task_unlock(tsk);
+#ifdef CONFIG_MOSIX_DFSA
+		put_used_fs_struct(fs);
+#else
 		__put_fs_struct(fs);
+#endif /* CONFIG_MOSIX_DFSA */
 	}
 }
 
@@ -307,6 +359,9 @@
 	struct mm_struct * mm = tsk->mm;
 
 	mm_release();
+#ifdef CONFIG_MOSIX
+	mosix_exit_mm(tsk);
+#endif /* CONFIG_MOSIX */
 	if (mm) {
 		atomic_inc(&mm->mm_count);
 		BUG_ON(mm != tsk->active_mm);
@@ -333,6 +388,14 @@
 	struct task_struct * p, *t;
 
 	forget_original_parent(current);
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DREMOTE)
+	{
+		current->state = TASK_ZOMBIE;
+		notify_parent(current, SIGCHLD);
+		return;
+	}
+#endif /* CONFIG_MOSIX */
 	/*
 	 * Check to see if any process groups have become orphaned
 	 * as a result of our exiting, and if they have any stopped
@@ -386,10 +449,24 @@
 	 */
 
 	write_lock_irq(&tasklist_lock);
+#ifndef CONFIG_MOSIX
 	current->state = TASK_ZOMBIE;
 	do_notify_parent(current, current->exit_signal);
+#endif /* CONFIG_MOSIX */
 	while (current->p_cptr != NULL) {
 		p = current->p_cptr;
+#ifdef CONFIG_MOSIX
+		if(p->ptrace && (p->mosix.dflags & DDEPUTY))
+		{
+			get_task_struct(p);
+			write_unlock_irq(&tasklist_lock);
+			request_process(p, NULL, PR_PTRACE_NOT_TRACED, 0);
+			p->ptrace = 0;
+			free_task_struct(p);
+			write_lock_irq(&tasklist_lock);
+			continue;
+		}
+#endif /* CONFIG_MOSIX */
 		current->p_cptr = p->p_osptr;
 		p->p_ysptr = NULL;
 		p->ptrace = 0;
@@ -399,7 +476,11 @@
 		if (p->p_osptr)
 			p->p_osptr->p_ysptr = p;
 		p->p_pptr->p_cptr = p;
+#ifdef CONFIG_MOSIX
+		if (LOGICAL_STATE(p) == TASK_ZOMBIE)
+#else
 		if (p->state == TASK_ZOMBIE)
+#endif /* CONFIG_MOSIX */
 			do_notify_parent(p, p->exit_signal);
 		/*
 		 * process group orphan check
@@ -419,6 +500,10 @@
 			write_lock_irq(&tasklist_lock);
 		}
 	}
+#ifdef CONFIG_MOSIX
+	current->state = TASK_ZOMBIE;
+	do_notify_parent(current, current->exit_signal);
+#endif /* CONFIG_MOSIX */
 	write_unlock_irq(&tasklist_lock);
 }
 
@@ -436,6 +521,9 @@
 	del_timer_sync(&tsk->real_timer);
 
 fake_volatile:
+#ifdef CONFIG_MOSIX
+	mosix_exit();
+#endif /* CONFIG_MOSIX */
 #ifdef CONFIG_BSD_PROCESS_ACCT
 	acct_process(code);
 #endif
@@ -447,6 +535,9 @@
 	__exit_fs(tsk);
 	exit_namespace(tsk);
 	exit_sighand(tsk);
+#ifdef CONFIG_MOSIX
+	mosix_very_exit();
+#endif /* CONFIG_MOSIX */
 	exit_thread();
 
 	if (current->leader)
@@ -526,7 +617,11 @@
 			    && !(options & __WALL))
 				continue;
 			flag = 1;
+#ifdef CONFIG_MOSIX
+			switch (LOGICAL_STATE(p)) {
+#else
 			switch (p->state) {
+#endif /* CONFIG_MOSIX */
 			case TASK_STOPPED:
 				if (!p->exit_code)
 					continue;
diff -Naur --exclude=CVS --exclude=configs linux/kernel/fork.c linux-openmosix/kernel/fork.c
--- linux/kernel/fork.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/kernel/fork.c	2004-05-19 00:32:34.000000000 +0200
@@ -10,6 +10,7 @@
  * Fork is rather simple, once you get the hang of it, but the memory
  * management can be a bitch. See 'mm/memory.c': 'copy_page_range()'
  */
+/* some openMosix fork changes introduce by Moshe Bar */
 
 #include <linux/config.h>
 #include <linux/slab.h>
@@ -29,6 +30,10 @@
 #include <asm/mmu_context.h>
 #include <asm/processor.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 /* The idle threads do not count.. */
 int nr_threads;
 int nr_running;
@@ -77,8 +82,14 @@
 	 */
 	max_threads = mempages / (THREAD_SIZE/PAGE_SIZE) / 8;
 
+#ifdef CONFIG_MOSIX
+	/* 1/6th of "max_threads" goes for guest tasks */
+	init_task.rlim[RLIMIT_NPROC].rlim_cur = max_threads/3;
+	init_task.rlim[RLIMIT_NPROC].rlim_max = max_threads/3;
+#else
 	init_task.rlim[RLIMIT_NPROC].rlim_cur = max_threads/2;
 	init_task.rlim[RLIMIT_NPROC].rlim_max = max_threads/2;
+#endif
 }
 
 /* Protects next_safe and last_pid. */
@@ -140,6 +151,16 @@
 	return 0;
 }
 
+#ifdef CONFIG_MOSIX
+/* NOTE: "dup_mmap" is called beyond the point of no migration:
+ * this means we are no longer allowed to sleep interruptibly here without
+ * taking special measures to prevent migration (such as raising a new flag
+ * in "current->mosix.stay"),
+ * Fortunately, vm_ops->open(tmp) is rarely non-NULL and even then, it never
+ * sleeps interruptibly.  BUT if it ever does, then we must take such measures
+ * to prevent migration here.
+ */
+#endif /* CONFIG_MOSIX */
 static inline int dup_mmap(struct mm_struct * mm)
 {
 	struct vm_area_struct * mpnt, *tmp, **pprev;
@@ -230,6 +251,13 @@
 static struct mm_struct * mm_init(struct mm_struct * mm)
 {
 	atomic_set(&mm->mm_users, 1);
+#ifdef CONFIG_MOSIX
+	atomic_set(&mm->mm_realusers, 1);
+	atomic_set(&mm->mm_kiocount, 0);
+	mm->last_memsort = 0;
+	mm->used = mm->unused = mm->swapped = mm->private_unused = 0;
+	mm->mark = 0;
+#endif /* CONFIG_MOSIX */
 	atomic_set(&mm->mm_count, 1);
 	init_rwsem(&mm->mmap_sem);
 	mm->page_table_lock = SPIN_LOCK_UNLOCKED;
@@ -336,6 +364,9 @@
 
 	if (clone_flags & CLONE_VM) {
 		atomic_inc(&oldmm->mm_users);
+#ifdef CONFIG_MOSIX
+		atomic_inc(&oldmm->mm_realusers);
+#endif /* CONFIG_MOSIX */
 		mm = oldmm;
 		goto good_mm;
 	}
@@ -359,6 +390,9 @@
 
 	if (retval)
 		goto free_pt;
+#ifdef CONFIG_MOSIX
+	tsk->mosix.stay &= ~DSTAY_FOR_CLONE;
+#endif /* CONFIG_MOSIX */
 
 	/*
 	 * child gets a private LDT (if there was an LDT in the parent)
@@ -382,13 +416,28 @@
 	/* We don't need to lock fs - think why ;-) */
 	if (fs) {
 		atomic_set(&fs->count, 1);
+#ifdef CONFIG_MOSIX_DFSA
+		atomic_set(&fs->users, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 		fs->lock = RW_LOCK_UNLOCKED;
 		fs->umask = old->umask;
 		read_lock(&old->lock);
 		fs->rootmnt = mntget(old->rootmnt);
 		fs->root = dget(old->root);
+#ifdef CONFIG_MOSIX
+		if(current->mosix.dflags & (DREMOTEDAEMON|DREMOTE))
+		{
+			fs->pwdmnt = NULL;
+			fs->pwd = NULL;
+		}
+		else
+		{
+#endif /* CONFIG_MOSIX */
 		fs->pwdmnt = mntget(old->pwdmnt);
 		fs->pwd = dget(old->pwd);
+#ifdef CONFIG_MOSIX
+		}
+#endif /* CONFIG_MOSIX */
 		if (old->altroot) {
 			fs->altrootmnt = mntget(old->altrootmnt);
 			fs->altroot = dget(old->altroot);
@@ -410,6 +459,9 @@
 {
 	if (clone_flags & CLONE_FS) {
 		atomic_inc(&current->fs->count);
+#ifdef CONFIG_MOSIX_DFSA
+		atomic_inc(&current->fs->users);
+#endif /* CONFIG_MOSIX_DFSA */
 		return 0;
 	}
 	tsk->fs = __copy_fs_struct(current->fs);
@@ -446,6 +498,9 @@
 
 	if (clone_flags & CLONE_FILES) {
 		atomic_inc(&oldf->count);
+#ifdef CONFIG_MOSIX_DFSA
+		atomic_inc(&oldf->users);
+#endif /* CONFIG_MOSIX_DFSA */
 		goto out;
 	}
 
@@ -461,6 +516,9 @@
 		goto out;
 
 	atomic_set(&newf->count, 1);
+#ifdef CONFIG_MOSIX_DFSA
+	atomic_set(&newf->users, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 
 	newf->file_lock	    = RW_LOCK_UNLOCKED;
 	newf->next_fd	    = 0;
@@ -469,6 +527,15 @@
 	newf->close_on_exec = &newf->close_on_exec_init;
 	newf->open_fds	    = &newf->open_fds_init;
 	newf->fd	    = &newf->fd_array[0];
+#ifdef CONFIG_MOSIX_DFSA
+	newf->closed	    = &newf->closed_fds_init;
+	newf->opened        = &newf->opened_fds_init;
+	newf->modified	    = &newf->modified_fds_init;
+	newf->maxclosed	    = 0;
+	newf->maxopened     = 0;
+	newf->maxmod	    = 0;
+	newf->count_dropped_to_one = 0;
+#endif /* CONFIG_MOSIX_DFSA */
 
 	/* We don't yet have the oldf readlock, but even if the old
            fdset gets grown now, we'll only copy up to "size" fds */
@@ -508,6 +575,11 @@
 
 	memcpy(newf->open_fds->fds_bits, oldf->open_fds->fds_bits, open_files/8);
 	memcpy(newf->close_on_exec->fds_bits, oldf->close_on_exec->fds_bits, open_files/8);
+#ifdef CONFIG_MOSIX_DFSA
+	memcpy(newf->closed->fds_bits, oldf->closed->fds_bits, open_files/8);
+	memcpy(newf->opened->fds_bits, oldf->opened->fds_bits, open_files/8);
+	memcpy(newf->modified->fds_bits, oldf->modified->fds_bits, open_files/8);
+#endif /* CONFIG_MOSIX_DFSA */
 
 	for (i = open_files; i != 0; i--) {
 		struct file *f = *old_fds++;
@@ -529,6 +601,11 @@
 		
 		memset(&newf->open_fds->fds_bits[start], 0, left);
 		memset(&newf->close_on_exec->fds_bits[start], 0, left);
+#ifdef CONFIG_MOSIX_DFSA
+		memset(&newf->closed->fds_bits[start], 0, left);
+		memset(&newf->opened->fds_bits[start], 0, left);
+		memset(&newf->modified->fds_bits[start], 0, left);
+#endif /* CONFIG_MOSIX_DFSA */
 	}
 
 	tsk->files = newf;
@@ -539,6 +616,11 @@
 out_release:
 	free_fdset (newf->close_on_exec, newf->max_fdset);
 	free_fdset (newf->open_fds, newf->max_fdset);
+#ifdef CONFIG_MOSIX_DFSA
+	free_fdset (newf->closed, newf->max_fdset);
+	free_fdset (newf->opened, newf->max_fdset);
+	free_fdset (newf->modified, newf->max_fdset);
+#endif /* CONFIG_MOSIX_DFSA */
 	kmem_cache_free(files_cachep, newf);
 	goto out;
 }
@@ -624,6 +706,34 @@
 	return ret;
 }
 
+#ifdef CONFIG_MOSIX
+long user_thread(int (*fn)(void *), void * arg, unsigned long flags)
+{
+	struct task_struct *task = current;
+	unsigned old_task_dumpable;
+	long ret;
+
+	/* lock out any potential ptracer */
+	task_lock(task);
+	if (task->ptrace) {
+		task_unlock(task);
+		return -EPERM;
+	}
+	
+	old_task_dumpable = task->task_dumpable;
+	task->task_dumpable = 0;
+	task_unlock(task);
+	
+	ret = arch_user_thread(fn, arg, flags);
+
+	/* never reached in child process, only in parent */
+	current->task_dumpable = old_task_dumpable;
+
+	return ret;
+}
+#endif /* CONFIG_MOSIX */
+
+
 /*
  *  Ok, this is the main fork-routine. It copies the system process
  * information (task[nr]) and sets up the necessary registers. It also
@@ -639,6 +749,9 @@
 	int retval;
 	struct task_struct *p;
 	struct completion vfork;
+#ifdef CONFIG_MOSIX
+	int migrated = 0;
+#endif /* CONFIG_MOSIX */
 
 	if ((clone_flags & (CLONE_NEWNS|CLONE_FS)) == (CLONE_NEWNS|CLONE_FS))
 		return -EINVAL;
@@ -653,6 +766,14 @@
 		if (current->pid)
 			goto fork_out;
 	}
+#ifdef CONFIG_MOSIX
+	if(!(current->mosix.stay ||
+		(current->mosix.dflags & (DDEPUTY|DREMOTE|DREMOTEDAEMON))))
+
+		migrated = mosix_forkmigrate();
+
+
+#endif /* CONFIG_MOSIX */
 
 	retval = -ENOMEM;
 	p = alloc_task_struct();
@@ -738,6 +859,10 @@
 	INIT_LIST_HEAD(&p->local_pages);
 
 	retval = -ENOMEM;
+#ifdef CONFIG_MOSIX
+	if(mosix_fork_init_fields(p))
+		goto bad_fork_cleanup;
+#endif /* CONFIG_MOSIX */
 	/* copy all the process information */
 	if (copy_files(clone_flags, p))
 		goto bad_fork_cleanup;
@@ -745,6 +870,17 @@
 		goto bad_fork_cleanup_files;
 	if (copy_sighand(clone_flags, p))
 		goto bad_fork_cleanup_fs;
+
+	/* we need to set the tgid here, so that it's available */
+	/* to mosix_deputy_fork  contributed by Muli and Gilad*/
+	p->tgid = ((clone_flags & CLONE_THREAD) ? current->tgid : p->pid);
+
+#ifdef CONFIG_MOSIX
+	if((current->mosix.dflags & DDEPUTY) &&
+		(retval = mosix_deputy_fork(p, migrated, stack_start)))
+		goto bad_fork_cleanup_sighand;
+	/* No migrations allowed beyond this point! */
+#endif /* CONFIG_MOSIX */
 	if (copy_mm(clone_flags, p))
 		goto bad_fork_cleanup_sighand;
 	retval = copy_namespace(clone_flags, p);
@@ -792,6 +928,14 @@
 	/* CLONE_PARENT re-uses the old parent */
 	p->p_opptr = current->p_opptr;
 	p->p_pptr = current->p_pptr;
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & (DREMOTE|DREMOTEDAEMON))
+	{
+		extern struct task_struct *child_reaper;
+		p->p_pptr = p->p_opptr = child_reaper;
+	}
+	else
+#endif /* CONFIG_MOSIX */
 	if (!(clone_flags & CLONE_PARENT)) {
 		p->p_opptr = current;
 		if (!(p->ptrace & PT_PTRACED))
@@ -809,12 +953,19 @@
 	write_unlock_irq(&tasklist_lock);
 
 	if (p->ptrace & PT_PTRACED)
+#ifdef CONFIG_MOSIX
+	if(!(p->mosix.dflags & DREMOTE))
+#endif /* CONFIG_MOSIX */
 		send_sig(SIGSTOP, p, 1);
 
 	wake_up_process(p);		/* do this last */
 	++total_forks;
 	if (clone_flags & CLONE_VFORK)
+#ifdef CONFIG_MOSIX
+		wait_for_completion_half_interruptible(&vfork);
+#else
 		wait_for_completion(&vfork);
+#endif /* CONFIG_MOSIX */
 
 fork_out:
 	return retval;
@@ -823,6 +974,8 @@
 	exit_namespace(p);
 bad_fork_cleanup_mm:
 	exit_mm(p);
+	if (p->active_mm)
+		mmdrop(p->active_mm);
 bad_fork_cleanup_sighand:
 	exit_sighand(p);
 bad_fork_cleanup_fs:
@@ -830,6 +983,9 @@
 bad_fork_cleanup_files:
 	exit_files(p); /* blocking */
 bad_fork_cleanup:
+#ifdef CONFIG_MOSIX
+	mosix_fork_free_fields(p);
+#endif /* CONFIG_MOSIX */
 	put_exec_domain(p->exec_domain);
 	if (p->binfmt && p->binfmt->module)
 		__MOD_DEC_USE_COUNT(p->binfmt->module);
diff -Naur --exclude=CVS --exclude=configs linux/kernel/panic.c linux-openmosix/kernel/panic.c
--- linux/kernel/panic.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/kernel/panic.c	2004-05-19 00:33:48.000000000 +0200
@@ -59,7 +59,7 @@
 	
 	bust_spinlocks(1);
 	va_start(args, fmt);
-	vsprintf(buf, fmt, args);
+	vsnprintf(buf, sizeof(buf), fmt, args);
 	va_end(args);
 	printk(KERN_EMERG "Kernel panic: %s\n",buf);
 	if (in_interrupt())
diff -Naur --exclude=CVS --exclude=configs linux/kernel/ptrace.c linux-openmosix/kernel/ptrace.c
--- linux/kernel/ptrace.c	2003-08-25 13:44:44.000000000 +0200
+++ linux-openmosix/kernel/ptrace.c	2004-03-10 02:27:25.000000000 +0100
@@ -21,6 +21,13 @@
  */
 int ptrace_check_attach(struct task_struct *child, int kill)
 {
+	mb();
+#ifdef CONFIG_MOSIX
+	if (!(child->mm ? is_dumpable(child) : (child->mosix.dflags & DDUMPABLE)))
+#else
+	if (!is_dumpable(child))
+#endif
+		return -EPERM;
 
 	if (!(child->ptrace & PT_PTRACED))
 		return -ESRCH;
@@ -29,7 +36,11 @@
 		return -ESRCH;
 
 	if (!kill) {
+#ifdef CONFIG_MOSIX
+		if (LOGICAL_STATE(child) != TASK_STOPPED)
+#else
 		if (child->state != TASK_STOPPED)
+#endif /* CONFIG_MOSIX */
 			return -ESRCH;
 #ifdef CONFIG_SMP
 		/* Make sure the child gets off its CPU.. */
@@ -39,20 +50,28 @@
 				break;
 			task_unlock(child);
 			do {
+#ifdef CONFIG_MOSIX
+				if (LOGICAL_STATE(child) != TASK_STOPPED)
+#else
 				if (child->state != TASK_STOPPED)
+#endif /* CONFIG_MOSIX */
 					return -ESRCH;
 				barrier();
 				cpu_relax();
 			} while (task_has_cpu(child));
 		}
 		task_unlock(child);
-#endif		
+#endif
 	}
 
 	/* All systems go.. */
 	return 0;
 }
 
+#ifdef CONFIG_MOSIX
+#include <hpc/request.h>
+#endif /* CONFIG_MOSIX */
+
 int ptrace_attach(struct task_struct *task)
 {
 	task_lock(task);
@@ -60,6 +79,9 @@
 		goto bad;
 	if (task == current)
 		goto bad;
+#ifdef CONFIG_MOSIX
+	if(!(task->mosix.dflags & DDEPUTY))
+#endif /* CONFIG_MOSIX */
 	if (!task->mm)
 		goto bad;
 	if(((current->uid != task->euid) ||
@@ -71,7 +93,12 @@
  	    (current->gid != task->gid)) && !capable(CAP_SYS_PTRACE))
 		goto bad;
 	rmb();
+#ifdef CONFIG_MOSIX
+	if (!(task->mm ? is_dumpable(task) : (task->mosix.dflags & DDUMPABLE))
+		&& !capable(CAP_SYS_PTRACE))
+#else
 	if (!is_dumpable(task) && !capable(CAP_SYS_PTRACE))
+#endif /* CONFIG_MOSIX */
 		goto bad;
 	/* the same process cannot be attached many times */
 	if (task->ptrace & PT_PTRACED)
@@ -105,6 +132,14 @@
 		return	-EIO;
 
 	/* Architecture-specific hardware disable .. */
+#ifdef CONFIG_MOSIX
+	if(child->mosix.dflags & DDEPUTY)
+	{
+		if(request_process(child, NULL, PR_PTRACE_CONT, PTRACE_DETACH))
+			return(-ESRCH);
+	}
+	else
+#endif /* CONFIG_MOSIX */
 	ptrace_disable(child);
 
 	/* .. re-parent .. */
@@ -123,7 +158,7 @@
 
 /*
  * Access another process' address space.
- * Source/target buffer must be kernel space, 
+ * Source/target buffer must be kernel space,
  * Do not walk the page table directly, use get_user_pages
  */
 
@@ -134,14 +169,35 @@
 	struct page *page;
 	void *old_buf = buf;
 
+#ifdef CONFIG_MOSIX
+	if (tsk->mosix.dflags & DDEPUTY)
+	{
+		return(request_process_arg2(tsk, buf,
+			write ? PR_PROCFS_MEM_WRITE : PR_PROCFS_MEM_READ,
+			(long) addr, len));
+	}					
+#endif
+
 	/* Worry about races with exit() */
 	task_lock(tsk);
 	mm = tsk->mm;
+	if (!is_dumpable(tsk))
+	{
+#ifdef CONFIG_MOSIX
+		if (!(tsk->mosix.dflags & DREMOTE))
+#endif
+			mm = NULL;
+	}
+	if (&init_mm == mm)
+	  	mm = NULL;
 	if (mm)
 		atomic_inc(&mm->mm_users);
 	task_unlock(tsk);
 	if (!mm)
+	{
 		return 0;
+	}
+	
 
 	down_read(&mm->mmap_sem);
 	/* ignore errors, just check how much was sucessfully transfered */
@@ -179,7 +235,7 @@
 	}
 	up_read(&mm->mmap_sem);
 	mmput(mm);
-	
+
 	return buf - old_buf;
 }
 
@@ -203,7 +259,7 @@
 		copied += retval;
 		src += retval;
 		dst += retval;
-		len -= retval;			
+		len -= retval;
 	}
 	return copied;
 }
@@ -228,7 +284,7 @@
 		copied += retval;
 		src += retval;
 		dst += retval;
-		len -= retval;			
+		len -= retval;
 	}
 	return copied;
 }
